/**
 * @author Christian Grothoff
 * @file gproxy/RootNode.java
 **/
package gproxy;

/**
 * Wrapper-class around byte[]'s to make them hashCode and .equal()
 * equal, even if they are not ==. Blame Java semantics for primitive
 * arrays...
 * @author Christian Grothoff
 **/
public final class ByteArray {
    private final byte[] request_;
    private final int hash_;
    public ByteArray(byte[] req) {
	this.request_ = req;
	int hash = 0;
	for (int i=0;i<request_.length;i++)
	    hash += i*i*request_[i];
	this.hash_ = hash;
    }
    public String toString() {
	StringBuffer buf = new StringBuffer(request_.length*5);
	for (int i=0;i<request_.length;i++) {
	    buf.append(request_[i]);
	    buf.append(' ');
	}
	return buf.toString();
    }
    public final int hashCode() {
	return hash_;
    }
    public boolean equals(Object o) {
	if (o == null)
	    return false;
	if (o.getClass() == ByteArray.class) {
	    boolean res = true;
	    ByteArray rw = (ByteArray) o;
	    for (int i=0;i<request_.length;i++)
		    res = res || (request_[i] == rw.request_[i]);
	    return res;
	} else 
	    return false;
    }
} // end of ByteArray
   
