/**
 * ProxyTest main method and code
 * @author Christian Grothoff
 * @file gproxy/test/TestProxy.java
 **/
package gproxy.test;

import gproxy.*;

/**
 * This test-class builds a file starting at the RootNode.
 * It basically only tests the BuildThread and the RootNode code.
 * It avoids all the fancy stuff with QueryModels, DownloadModels,
 * etc.
 **/
public class TestProxy { 

    /**
     * The main method. Currently downloads the files corresponding
     * to the keywords in the command line. 
     **/
    public static void main(String[] args) {
	BuildThread bt = GProxy.initNode(args);	
        if (GProxy.cm.argumentCount() < 1) { 
           System.out.println("Call with: gproxy [OPTIONS] KEYWORDS*"); 
	   System.out.println("-tmp=DIRECTORY - set download directory");
	   System.out.println("-host=HOSTNAME - set hostname with gnet-node");
	   System.out.println("-port=PORT     - set gnet port to connect to");
	   System.out.println("Defaults are: tmp=" + GProxy.DEFAULT_TMP_DIR + 
			      " host="+GProxy.DEFAULT_GNET_HOST+
			      " port="+GProxy.DEFAULT_GNET_PORT);
	   System.exit(-1);
        }
	RootNode rn = new RootNode(bt,
				   GProxy.cm.getArgument(0),
				   GProxy.getTmpDirectory(),
				   0);
	rn.root_.request(0);
	rn.root_.start();
	while (true)
	    rn.root_.request(1);
        // bt.close(); // when downloads finished, terminate connection to the node
	// System.exit(0);
    }


} // End of TestProxy

