/*
 * File:  semaphore.h
 *
 */
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

#ifndef SEMAPHORES
#define SEMAPHORES

typedef struct Semaphore
{
    int         v;
    pthread_mutex_t mutex;
    pthread_cond_t cond;
}
Semaphore;

extern Semaphore * new_semaphore (int value);
extern int      semaphore_down (Semaphore * s);
extern int      semaphore_decrement (Semaphore * s);
extern int      semaphore_up (Semaphore * s);
extern void     semaphore_destroy (Semaphore * s);
extern void     semaphore_init (Semaphore * s);
extern int      semaphore_value (Semaphore * s);
extern int      tw_pthread_cond_signal (pthread_cond_t * c);
extern int      tw_pthread_cond_wait (pthread_cond_t * c, pthread_mutex_t * m);
extern int      tw_pthread_mutex_unlock (pthread_mutex_t * m);
extern int      tw_pthread_mutex_lock (pthread_mutex_t * m);
extern int      tw_pthread_mutex_init (pthread_mutex_t * m, 
				       const pthread_mutexattr_t *lock_attr);
extern void     do_error (char *msg);

#endif
