/**
 * This module generates sequence numbers for the local node.
 * @file primitives/sequencer.c
 * @author Christian Grothoff
 **/

#include "sequencer.h"

/**
 * Internal: the lasts sequence number
 **/
unsigned int sequenceNumber;

/**
 * This method is called whenever a new (part of)
 * a packet is send. 
 * @returns the sequence number of the packet
 **/
unsigned int bumpCounter() {
  return sequenceNumber++;
}

/**
 * @return the current sequence number.
 **/
unsigned int getSequenceNumber() {
  return sequenceNumber;
}

/* end of sequencer.c */
