/**
 * Sessionkey generation/exchange testcode.
 * This is the testcase!
 * @author Christian Grothoff
 * @file gnet/database/test/sessionkeytest.c
 **/

#include <stdio.h>
#include <string.h>
#include "sessionkey.h"
#include "keyservice.h"

int testMakeSessionKeySigned() {
  HostIdentity hostId;
  SESSIONKEY sessionkey;
  time_t created;
  SKEY_Message ret;

  time(&created);
  getHostIdentity(getPublicHostkey(),
		  &hostId);
  if (1 == makeSessionKeySigned(&hostId,
				&sessionkey,
				created,
				&ret))
    return 0;
  else
    return 1;
}

int main(int argc, char * argv[]) {
  int failureCount = 0;
  
  readConfig(DEFAULT_CONFIG_FILE);
  initAddress();
  initKeyService();
  failureCount += testMakeSessionKeySigned();

  if (failureCount == 0)
    return 0;
  else {
    printf("%d TESTS FAILED!\n",failureCount);
    return -1;
  }
} // end of main
